/* CLIENT_TEST.C	X0.0
 | Testing a client mode to tacacs.
 */
#include "includes.h"
#define	errno	socket_errno	/* Multinet calls it Socket_Errno */
#define	read	socket_read
#define	write	socket_write
#define	close	socket_close
#define	perror	socket_perror

/*
 * TACACS protocol defintions
 */
#define uchar unsigned char
#define ulong unsigned long
#include "tacacs.h"

#define	LINESIZE	256

main()
{
	char	*p, username[LINESIZE], password[LINESIZE];
	unsigned char	buffer[1024];
	xtacacstype	*TacacsPacket;
	int	s, size;
	struct	sockaddr_in	RemoteSocket;

again:
	printf("Username: "); gets(username);
	printf("Password: "); gets(password);

	if((p = strchr(username, '\n')) != NULL) *p = '\0';
	if((p = strchr(password, '\n')) != NULL) *p = '\0';

/* Create a tacacs packet */
	TacacsPacket = (xtacacstype *)buffer;
	TacacsPacket->version = XTA_VERSION;	/* Extended tacacs */
	TacacsPacket->type = XTA_LOGIN;		/* Login access type */
	TacacsPacket->trans = 1;	/*~~~*/
	TacacsPacket->namelen = strlen(username);
	TacacsPacket->pwlen = strlen(password);
	TacacsPacket->response = 0;
	TacacsPacket->reason = 0;
	TacacsPacket->uuid = 0;
	TacacsPacket->dhost = 0;
	TacacsPacket->dport = 0;
	TacacsPacket->lport = 0;
	TacacsPacket->flags = 0;
	TacacsPacket->accesslist = 0;

/* Make the xmission buffer */
	strcpy(buffer+XTACACSSIZE, username);
        strcpy(buffer+XTACACSSIZE + TacacsPacket->namelen, password);
        size = XTACACSSIZE + TacacsPacket->namelen + TacacsPacket->pwlen;   /* Total size */

/* Create a socket */
/* Create a local socket */
	if((s = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("Socket");
		return;
	}

/* Fill the Sockaddr parameters */
	bzero((caddr_t)&RemoteSocket, sizeof(RemoteSocket));
	RemoteSocket.sin_addr.s_addr = htonl(0x7f000001);
	RemoteSocket.sin_family = AF_INET;
	RemoteSocket.sin_port = htons(TACACS_PORT);

	if(sendto(s, buffer, size, 0, &RemoteSocket, sizeof(RemoteSocket)) < size) {
		perror("Sendto"); close(s); return;
	}

	if(recvfrom(s, buffer, XTACACSSIZE, 0, &RemoteSocket, &size) < XTACACSSIZE) {
		perror("Recvfrom"); close(s); return;
        }

	close(s);

	switch(TacacsPacket->response) {
	case XTA_A_ACCEPTED: printf("Accepted\n"); break;
	case XTA_A_REJECTED: printf("Rejected, reason=%d\n", TacacsPacket->reason);
		break;
	default: printf("Unknown response code %d\n", TacacsPacket->response);
	}
	goto again;
}
